/** fichier station.h **/
#include "libcom.h"

/***************************************************/
/* Structures necessaires pour la station IMAP2    */
/***************************************************/

/******* Constantes *******/
#define MAX_LIGNE 2048
#define MAX_TAMPON 1024

const int MAX_connexions = 6; //maximum 6 clients dans la file d'attente TCP

const char Flag_R[] = "\\RECENT\n";
const char Flag_S[] = "\\SEEN\n";
const char Flag_D[] = "\\DELETED\n";
const char Flag_A[] = "\\ANSWERED\n";
const char Flag_F[] = "\\FLAGGED\n";

char element_Envelope[9][MAX_LIGNE] = {"Date:", "Subject", "From:", "Sender:", "cc:", "In-Reply-To:", "Message-ID:", "Reply-To:", "To:"};

char element_Header[14][MAX_LIGNE] = {"Date:", "Subject", "From:", "Sender:", "cc:", "In-Reply-To:", "Message-ID:", "Mail-From:", "ReSent-Date:", "ReSent-To:", "ReSent-To:", "ReSent-Message-ID:", "Reply-To:", "To:"};
const char reponse_log0[] = "OK IMAP2 Server Ready \n\r";
const char reponse_log1[] = "OK User logged in \n";
const char reponse_log2[] = "NO wrong  password \n";
const char reponse_log3[] = "BAD FONCTION UNKNOWN\n";
const char reponse_log4[] = "OK Logout complete\n";
const char reponse_log5[] = "OK NOOP\n";
const char reponse_log8[] = "BAD MAILBOX selected does not exist\n";
const char reponse_log9[] = "NO user does not exist\n";
const char reponse_log10[] = "NO you are not connected\n";
const char reponse_log11[] = "OK Select complete\n";
const char reponse_log12[] = "OK Check complete\n";
const char reponse_log13[] = "OK Expunge complete\n";
const char reponse_log14[] = "NO error at name flags try this syntax +Flags \"\\Recent,\\Deleted...\"\n";
const char reponse_log15[] = "OK Store complete\n";
const char reponse_log16[] = "NO error at fetch commande try this syntax X:X (X=number) then (ALL/FAST/RFC822...)\"\n";

/** Variables publiques  **/
//int s=3;
char *port = "993"; // faire attention à ne pas choisir un port utilisé par le système
char *chemin_spool = "";
int adresse = 0;
/** Structures **/
typedef struct
{
	int Recent;
	int Deleted;
} nombre_flags_t;

typedef struct
{
	int iEnvelope;
	int iFlags;
	int iRfc_header;
	int iRfc_text;
	int iRfc_size;
	int iInternaldate;
} fetch_t;

/** Prototypes fonctions**/
int VerifLogin(char *, char *);
int Nombre_mail(char *, char *);
nombre_flags_t Lect_Flags(char *, nombre_flags_t, int, int *, int *, char[]);
int Sup_Ligne(char *, char *, int);
void Ajt_Ligne(char *, char *, char *);
int Enum_nb(char[], char *, int *, char[], FILE *);
void fct_copy(char *, char *, int *, int);
void Lect_Mail(fetch_t, FILE *, char *, int *, int);
void serveur_TCP(void);
int gestionClientTCP(int s);
int multi_gestionClientTCP(int s);
int Login(char[], char[], char[], FILE *);
int Logout(char[], FILE *);
void Noop(char[], FILE *);
void Select(char[], char[], nombre_flags_t, int *, int *, FILE *, char[]);
void Check(char[], char[], nombre_flags_t, int *, int *, FILE *, char[]);
void Expunge(char[], char[], nombre_flags_t, int *, int *, FILE *, char[]);
void Store(char[], char[], char[], char[], char[], FILE *);
void Copy(char[], char[], char[], char[], int *, FILE *);
void Fetch(char[], char[], char[], char[], int *, fetch_t, FILE *);
char *analyseArguments(int, char *[]);
int Pose_verrou(char *);
int Enleve_verrou(char *, FILE *, int);
